% example 7.1 from paper

fprintf('example 7.1 from paper\n')
close all
load B_N_airports
nairp = 305;
nhour = 24;

B = B_N(1:nhour*nairp,1:nhour*nairp);

figure(100)
spy(B_N)
set(gca,'fontsize',12)
title('Data matrix')
drawnow

tic
y = recbcen(B,nairp,nhour,1);
time_elapsed = toc

% comparison to expm
%tic
%eBN2 = expm(B);
%y1 = sum(eBN2,2);
%time_elapsed1 = toc

S = reshape(y,[305,nhour])';

figure(1)
h1 = plot(S);
xlim([1 nhour])
if nhour>12, set(gca,'xtick',[1 6:6:24]), end
xlabel('Time (hours)')
ylabel('Broadcasting centrality')
set(gca,'fontsize',12)
c1 = get(h1(19),'color');
c2 = get(h1(213),'color');
c3 = c1([2 3 1]);
c4 = c1([3 1 2]);
set(h1(159),'color',c3)
set(h1(157),'color',c4)
set(h1(19),'linewidth',2)
set(h1(213),'linewidth',2)
set(h1(159),'linewidth',2)
set(h1(157),'linewidth',2)
set(h1(19),'linestyle','-')
set(h1(213),'linestyle','--')
set(h1(159),'linestyle','-.')
set(h1(157),'linestyle',':')
p1 = get(gcf,'position');
p1(4) = round(p1(4)*2/3);
set(gcf,'position',p1)

figure(2)
x = linspace(1,nhour,nhour);
h2 = plot(x,S(:,19),x,S(:,213),x,S(:,159),x,S(:,157));
xlim([1 nhour])
if nhour>12, set(gca,'xtick',[1 6:6:24]), end
xlabel('Time (hours)')
ylabel('Broadcasting centrality')
set(gca,'fontsize',12)
legend('ATL','ORD','LAX','LAS')
set(h2(1),'color',c1)
set(h2(2),'color',c2)
set(h2(3),'color',c3)
set(h2(4),'color',c4)
set(h2(1),'linewidth',2)
set(h2(2),'linewidth',2)
set(h2(3),'linewidth',2)
set(h2(4),'linewidth',2)
set(h2(1),'linestyle','-')
set(h2(2),'linestyle','--')
set(h2(3),'linestyle','-.')
set(h2(4),'linestyle',':')
p2 = get(gcf,'position');
p2(4) = round(p2(4)*2/3);
set(gcf,'position',p2)

